﻿/*
 * RSP Software
 * 
 * Sample code
 * 
 * Thu Dec 20 22:41:25 2007
 * 
 * http://rspsoftware.bighost.com.br
 * info@rspsoftware.bighost.com.br
 * 
 */

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace bzip2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            axRSPBzip21.About();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox1.Items.Add("1");
            comboBox1.Items.Add("2");
            comboBox1.Items.Add("3");
            comboBox1.Items.Add("4");
            comboBox1.Items.Add("5");
            comboBox1.Items.Add("6");
            comboBox1.Items.Add("7");
            comboBox1.Items.Add("8");
            comboBox1.Items.Add("9");
            comboBox1.Text = "6";

            this.Text = axRSPBzip21.ControlName().ToString() + " - Sample";

            label5.Text = "CPU vendor : " + axRSPBzip21.GetCPUVendor().ToString();

            label6.Text = "CPU brand string : " + axRSPBzip21.GetCPUBrandString();

        }

        private void button1_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            textBox1.Text = openFileDialog1.FileName;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            textBox2.Text = openFileDialog1.FileName;

        }

        private void button3_Click(object sender, EventArgs e)
        {
            openFileDialog1.FileName = "";
            openFileDialog1.ShowDialog();
            textBox3.Text = openFileDialog1.FileName;

        }

        private void comboBox1_TextChanged(object sender, EventArgs e)
        {
            int ret;
            // MessageBox.Show("text changed");
            try
            {
                ret = int.Parse(comboBox1.Text);
            }
            catch
            {
                comboBox1.Text = "6";
            }

        }
        private int First = 0;
        private void button4_Click(object sender, EventArgs e)
        {
            label4.Text = "Status : Executing ";

            label9.Text = "Elapsed : ...";
            this.Refresh();
            First = System.Environment.TickCount;

            if (checkBox1.CheckState == CheckState.Unchecked)
            {
                //   'Old mode , limited to 2 GB , no additional information from file

                int ret = int.Parse(comboBox1.Text);
                axRSPBzip21.Compress(textBox1.Text, textBox2.Text, ref ret);
            }
            else
            {
                //  'Recommended , no file size limit and MD5 as integrity check
                //  'also stores file attributes and the file time as last modified and
                //  'file creation time
                int ret = int.Parse(comboBox1.Text);
                axRSPBzip21.CompressBzip3(textBox1.Text, textBox2.Text, ref ret);
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            label4.Text = "Status : Executing ";

            label9.Text = "Elapsed : ...";
            this.Refresh();
            First = System.Environment.TickCount;


            if (checkBox1.CheckState == CheckState.Unchecked)
            {

                // 'Old mode , limited to 2 GB , no additional information from file
                axRSPBzip21.Decompress(textBox2.Text, textBox3.Text);
            }
            else
            {
                // 'Recommended , no file size limit and MD5 as integrity check
                // 'also stores file attributes and the file time as last modified and
                //  'file creation time
                axRSPBzip21.DecompressBzip3(textBox2.Text, textBox3.Text);
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (true == axRSPBzip21.Status())
            {
                label4.Text = "Status : Paused ";
            }

            axRSPBzip21.PauseCompress();
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (true == axRSPBzip21.Status())
            {
                label4.Text = "Status : Executing ";
            }

            axRSPBzip21.ResumeCompress();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            axRSPBzip21.CancelCompress();
        }

        private void button9_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        private int counter = 0;
        private void axRSPBzip21_ErrorCode(object sender, AxRSPBzip2_a210.__RSPBzip2_ErrorCodeEvent e)
        {

            counter++;
            listBox1.Items.Add(counter.ToString() + " - " + e.errorNumber.ToString() + " - " + e.errorDescription);
            int ret;

            ret = listBox1.Items.Count;
            listBox1.SelectedIndex = ret - 1;

        }

        private void axRSPBzip21_Finished(object sender, EventArgs e)
        {
            First = System.Environment.TickCount - First;
            double a = First;
            a = a / 1000;
            label9.Text = "Elapsed : " + a.ToString();

            label4.Text = "Status : Finished ";
        }

        private void axRSPBzip21_Progress(object sender, AxRSPBzip2_a210.__RSPBzip2_ProgressEvent e)
        {
            progressBar1.Value = e.progressvalue;
        }
    }
}
